/******************************************************************************
    Program search.cgi, search thru database to match word(s):
    - chrstr.c - source file for working with letters

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "extern.h"

void spacetoplus(unsigned char *str);

/************ convert signature from match case to ignore ********************/
void IgnoreCase(unsigned char *BLin)
{
int i,j,dec[8];
short int svi[96];

dec[7]=1;dec[6]=2;dec[5]=4;dec[4]=8;dec[3]=16;/* set decimal numbers */
dec[2]=32;dec[1]=64;dec[0]=128;/* set decimal numbers */
for(i=0;i<12;i++){/* go thru signature */
 for(j=i*8;j<i*8+8;j++){/* go thru binary signature */
  if((dec[j-i*8]&BLin[i])==dec[j-i*8]) svi[j]=true;/* matched */
  else svi[j]=false;/* not matched */
 }/* end for j */
}/* end for i */
for(i=32;i<=57;i++){/* replace upper to lover */
 svi[i+32]|=svi[i];svi[i]=0;
}/* end for i */
for(i=0;i<12;i++){/* go thru numbers */
 BLin[i]=0;
 for(j=i*8;j<i*8+8;j++)/* go thru string */
  if(svi[j]) BLin[i]+=dec[j-i*8];/* set to character code */
}/* end for i */
}/* end IgnoreCase() */

/************************** create url link *****************************/
void AddToLnk(int BrSec,int WherE)
{
int i;

printf("<A HREF=\"%s?search=",getenv("SCRIPT_NAME"));/*create begining of link*/
for(i=0;i<=CUR_WORD;i++){ /* go thru words and add it */
 if(i>0) printf("+"); /* separate words */
 switch (WordS[i].stat[1]){/* determine staus of word */
  case -1:/* it's "not" type */
          printf("-%%22");spacetoplus(WordS[i].word);printf("%%22");break;
  case 0:/* it's "and" type */
	  printf("%%2B%%22");spacetoplus(WordS[i].word);printf("%%22");break;
  case 1:/* it's "or" type */
	  printf("%%22");spacetoplus(WordS[i].word);printf("%%22");break;
  case 2:/* it's "not *" type */
	  switch (WordS[i].stat[2]){/* determine staus of substring */
	   case -1:/* "*XXX" type */
		   printf("-*%%22");spacetoplus(WordS[i].word);
		   printf("%%22");break;
	   case 0:/* "*XXX*" type */
		   printf("-*%%22");spacetoplus(WordS[i].word);
		   printf("%%22*");break;
	   case 1:/* "XXX*" type */
		   printf("-%%22");spacetoplus(WordS[i].word);
		   printf("%%22*");break;
	  }break;/* end of switch of substring */
  case 3:/* it's "and *" type */
	  switch (WordS[i].stat[2]){/* determine staus of substring */
	   case -1:/* "*XXX" type */
		   printf("%%2B*%%22");spacetoplus(WordS[i].word);
		   printf("%%22");break;
	   case 0:/* "*XXX*" type */
		   printf("%%2B*%%22");spacetoplus(WordS[i].word);
		   printf("%%22*");break;
	   case 1:/* "XXX*" type */
		   printf("%%2B%%22");spacetoplus(WordS[i].word);
		   printf("%%22*");break;
	  }break;/* end of switch of substring */
  case 4:/* it's "or *" type */
	  switch (WordS[i].stat[2]){/* determine staus of substring */
	   case -1:/* "*XXX" type */
		   printf("*%%22");spacetoplus(WordS[i].word);
		   printf("%%22");break;
	   case 0:/* "*XXX*" type */
		   printf("*%%22");spacetoplus(WordS[i].word);
		   printf("%%22*");break;
	   case 1:/* "XXX*" type */
		   printf("%%22");spacetoplus(WordS[i].word);
		   printf("%%22*");break;
	  }break;/* end of switch of substring */
 }/* end switch */
 fflush(NULL);
}/* end for i */
printf("&type=%d&count=%d",TypCase,CounT);/* search mode and display count */
for(i=1;i<=CUR_SECT;i++){ /* Write included sections */
 if(i==BrSec) printf("&FsecT=%d",i);/* set first selected section */
 else if(section[i].stat!=0) printf("&SecT=%d",i);/* normal selected section */
}/* end for i */
if(WherE>0) printf("&SCounT=%d",WherE); /* write start position */
printf("\">");
}/* end AddToLnk() */

/************************** replace url location *************************/
void replace(char *URLoc)
{
char lin[1024],tmp[1024];
int i,j,L,U;
short int tst;
FILE *f;

if( (f=fopen(REPLACE,"r"))==NULL ){/* check replace file for reading */
 printf("<!-- Can't load replace file: %s -->\n",REPLACE);REPLACE[0]=0;
}else{/* all ok read file */
 while(!feof(f)){/* go thru file */
  lin[0]=0;fgets(lin,1024,f);/* read line */
  if( (lin[0]!=32)&&(lin[0]!='\n')&&(lin[0]!=' ')&&(lin[0]!='#')&&(lin[0]!=0) ){  /* read only uncomment lines */
   L=strlen(lin)-1;lin[L]=0;U=strlen(URLoc);/* remove newline character */
   if( L <= U ){/* line ok */
    tst=false;
    for(i=0;(i<=U-L)&&(!tst);i++){/* test if substring of URLoc is match */
     if( URLoc[i]==lin[0] ){ /* it culd be it */
      tst=true;/* reset check */
      for(j=0;j<L;j++) if(lin[j]!=URLoc[j+i]) tst=false;/* nope it's not */
     }/* end if url=lin */
    }/* end if for i */
    lin[0]=0;fgets(lin,1024,f);/* read next line */
    if(tst){/* do replace */
     i--;U=i+L;L=strlen(lin)-1;lin[L]=0; /* remove newline character */
     for(j=0;j<i;j++) tmp[j]=URLoc[j]; /* add first part of url */
     for(j=i;j<=L+i;j++) tmp[j]=lin[j-i]; /* replace string */
     for(j=U;j<=strlen(URLoc);j++) tmp[L+i+j-U]=URLoc[j];/* add last part */
     strcpy(URLoc,tmp);
    }/* end if tst */
   }else{/* not for that match, go to next line */
    lin[0]=0;fgets(lin,1024,f);/* read next line for skipp */
   }/* end else lenght < */
  }/* end if not comment */
 }/* end while feof */
 fclose(f);
}/* end else if fopen */
}/* end replace() */

/*************** remove more than one space character **********************/
void cutspace(char *lin)
{
char *i,*p;
int j;

p=lin;/* mark begining of line */
while(*lin){/* go thru line */
 if(*lin==32){/* found space character */
  i=lin+1;j=-1; while(*lin==32) {lin++;j++;} /* found end of space */
  lin=i; while(*lin) {*lin=*(lin+j);lin++;} /* recopy other characters */
  lin=i;}/* reset to last scaned location */
 lin++;/* continue scaning next character */
}/* end while */
if(*(lin-2)==32) *(lin-2)=0;/* remove last space character */
lin=p;/* reset to begining */
if(*lin==32) /* first character is space, remove it */
 while(*lin) {*lin=*(lin+1);lin++;}/* remove first character */
}/* end cutspace() */
