/******************************************************************************
    Program url2data, builds database from url address:
    - obrada.c - source file for dumping and testig url address.

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "url2data.h"

int getword(char *OutLin,FILE *file);/* read word from file */
void getletters(char *Ulin,unsigned char *Icode);/* make code of no letters */
void fix_line(char *Ulin);/* convert all other characters to '.' */
int decodeline(unsigned char *Ulin);/* mark line with signatures */
short int UrlInDatabase(unsigned char *ChkUrl);/*test existance of url in base*/
void getdesc(void);/* scan surce for description */
void parse_url(char UrlBegin[1024]);/* extract urls from source */

short int geturlloc(char *UrlLoc)/* add url location to database */
{
FILE *d,*f;
char exetxt[2048];
unsigned char lin[512],sbr[5];
short int test;
int i,j,numerr;
unsigned long filsiz;

/* get info from url */
if(E_OPT){/* check database */
 printf("\r%79s\rChecking existance in database ..."," ");
 test=!UrlInDatabase(UrlLoc);printf(" Done.");/* end if E options */
}else test=true;/* no need for test */
if(test){/* ok link don't exists in database, retrive it */
 printf("\rScaning %s\nRetrieve url information ...",UrlLoc);fflush(NULL);
 exetxt[0]=0;/* make template for execution */
 sprintf(exetxt,"lynx %s \"%s\" > %s",DUMPINFO,UrlLoc,logdbase);
 system(exetxt);/* execute template */
 printf(" Done.");

 test=false;if(!U_OPT) strcpy(date,"\n");filsiz=0;/* reset value */
 f=fopen(logdbase,"r");/* open tmp log file */
 while(!feof(f)){/* go thru log file */
  exetxt[0]=0;fgets(exetxt,2048,f);/* read line in log file */
  if(strncmp(exetxt,"HTTP/",4)==0){/* found http error level */
   for(i=9;i<=11;i++) exetxt[i-9]=exetxt[i];exetxt[3]=0;
   numerr=atoi(exetxt);/* retrieve error code */
   switch (numerr) {
    case 200: test=true;break;/* url file exists */
    case 301: test=2;break;/* url file moved, follow */
   }/* end switch thru numerr */
  }/* end if error level */
  if(strncmp(exetxt,"Last-Modified:",13)==0){/* found date */
   if((U_OPT==1)&&(strncmp(date,exetxt,strlen(exetxt)-2)==0))test=3;/* ident. */
   else strcpy(date,exetxt);/* copy line to date */
  }/* end found date */
  if( (strncmp(exetxt,"Location:",8)==0)&&(test==2) ){/* found new location */
   numerr=strlen(exetxt);/* get string size */
   for(i=10;i<numerr;i++) exetxt[i-10]=exetxt[i];
   exetxt[numerr-11]=0;geturlloc(exetxt);/* do another scan */
  }/* end location */
  if(strncmp(exetxt,"Content-Length:",14)==0){/* found url size */
   numerr=strlen(exetxt);/* get string size */
   for(i=16;i<numerr;i++) exetxt[i-16]=exetxt[i];
   exetxt[numerr-17]=0;filsiz=atol(exetxt);/* remember url size */
  }/* end location */
 }/* end while */
 rewind(f);fgets(exetxt,2048,f);fclose(f);/* get info from url */

 if(test==false){/* url error, display */
  printf("\rError on url location: %s\n",exetxt);fflush(NULL);
 }else{/* check other options */
 if(filsiz>1000000) sprintf(exetxt," - %ldM bytes\n",ldiv(filsiz,1000000).quot);
  else if(filsiz>1000) sprintf(exetxt," - %ldK bytes\n",ldiv(filsiz,1000).quot);
  else sprintf(exetxt," - %ld bytes\n",filsiz);/* get short size */
  fix_line(date);date[strlen(date)-1]=0;strcat(date,exetxt);/*copy url lenght */
  if( (test==2)||(test==3) ) test=false;/* nothing to do */
  if( (E_OPT)&&(test) ){/* check database */
   printf("\r%79s\rChecking existance in database ..."," ");
   test=!UrlInDatabase(UrlLoc);printf(" Done.");}/* end if E options */
  if(test){/* url file exists continue */
   d=fopen(database,"ab");/* open database for update */
   fprintf(d,"%c%s\n%c%s",255,UrlLoc,254,date);/* write location and date */
   fclose(d);/* close database file */
   printf("\r%79s\rFound OK, Dumping url location ..."," ");fflush(NULL);
   exetxt[0]=0;sprintf(exetxt,"lynx %s \"%s\" > %s",DUMPSRC,UrlLoc,fixhtml);
   system(exetxt);/* execute template (dump source file) */
   printf(" Done.");fflush(NULL);descr[0]=0;getdesc();/* scan for description */
   if(R_OPT) parse_url(UrlLoc);/* extract urls */
   printf("\r%79s\rProcessing complete, convert to plain text..."," ");
   fflush(NULL);/* redump to logdbase */
   exetxt[0]=0;sprintf(exetxt,"lynx %s -crawl %s > %s",DUMPURL,fixhtml,logdbase);
   system(exetxt);/* execute template (dump file) */
   printf(" Done.");fflush(NULL);
 
   f=fopen(logdbase,"r");/* open tmp log file */
   exetxt[0]=0;fgets(exetxt,2048,f);filsiz=ftell(f);/* get location */
   fgets(exetxt,2048,f);/* read line in log */
   if(strncmp(exetxt,"THE_TITLE:",9)==0){/* ok it have title */
    numerr=strlen(exetxt);for(i=10;i<=numerr;i++) exetxt[i-10]=exetxt[i];
    exetxt[i-12]=0;exetxt[128]=0;/* upper limit of 128 char */
   }else{/* don't have title, skipp */
    exetxt[0]=0;fseek(f,filsiz,SEEK_SET);/* set to end of url line */
   }/* end else title */
   d=fopen(tmploc,"wb");/* open tmp database for write */
   fprintf(d,"%c%s\n",252,exetxt);/* write title */
   if(descr[0]==0) descr[0]=255;/* not found description */
   else{ fprintf(d,"%c%s\n",251,descr);descr[0]=0;}/* write description */
   fclose(d);/* close temp file and reset decr */
   lin[0]=0;numerr=0;/* set number of char in line ( <=255 ) */
   do{/* go thru file */
    j=getword(exetxt,f);/* read next word */
    if(j+numerr<=255){/* add word to line */
     strcat(lin," ");strcat(lin,exetxt);
     numerr+=j;
    }else{/* line is full, write it to file */
     fix_line(lin);/* convert other characters to '.' */
     if(descr[0]==255) strncpy(descr,lin,120);/* no description, copy line */
     getletters(lin,date);/* make letters repeating count */
     numerr=decodeline(lin);/* mark line with signature */
     sbr[0]=div(numerr,256).quot;/* get first number */
     sbr[1]=numerr-sbr[0]*256;/* get second number */
     d=fopen(tmploc,"ab");/* open tmp database for update */
     if(descr[0]!=0){ fprintf(d,"%c%s\n",251,descr);/* write description */
     descr[0]=0;}/* end if desc[0]!=0 and set to 0 */
     for(i=0;i<=11;i++) fputc(date[i],d);/* write 12 marcation for letters */
     fputc(sbr[0],d);fputc(sbr[1],d);/* write lenght of line */
     for(i=0;i<numerr;i++) fputc(lin[i],d);/* write line data with marcation */
     fclose(d);/* close database for update */
     numerr=j;lin[0]=0;strcat(lin," ");strcat(lin,exetxt);/*reset to new input*/
    }/* end else line full */
   }while(!feof(f));fclose(f);
   if(numerr>0){/* do last entry in file */
    fix_line(lin);/* convert other characters to '.' */
    if(descr[0]==255) strncpy(descr,lin,120);/* no description, copy line */
    getletters(lin,date);/* make letters repeating count */
    numerr=decodeline(lin);/* mark line with signature */
    sbr[0]=div(numerr,256).quot;/* get first number */
    sbr[1]=numerr-sbr[0]*256;/* get second number */
    d=fopen(tmploc,"ab");/* open tmp database for update */
    if(descr[0]!=0){ fprintf(d,"%c%s\n",251,descr);/* write description */
    descr[0]=0;}/* end if desc[0]!=0 and set to 0 */
    for(i=0;i<=11;i++) fputc(date[i],d);/* write 12 marcation for letters */
    fputc(sbr[0],d);fputc(sbr[1],d);/* write lenght of line */
    for(i=0;i<numerr;i++) fputc(lin[i],d);/* write line data with marcation */
    fclose(d);/* close database for update */
   }/* end if last entry */
   d=fopen(tmploc,"rb");fseek(d,0L,SEEK_END);filsiz=ftell(d);fclose(d);
   sbr[3]=filsiz-(256*div(filsiz,256).quot);/* first number */
   filsiz=div(filsiz,256).quot;
   sbr[2]=filsiz-(256*div(filsiz,256).quot);/* second number */
   filsiz=div(filsiz,256).quot;
   sbr[1]=filsiz-(256*div(filsiz,256).quot);/* third number */
   filsiz=div(filsiz,256).quot;
   sbr[0]=filsiz-(256*div(filsiz,256).quot);/* fourth number */
   printf("\r%79s\rWriting to database ..."," ");fflush(NULL);
   d=fopen(database,"ab");/* open database for update */
   fprintf(d,"%c%c%c%c%c",253,sbr[0],sbr[1],sbr[2],sbr[3]);/* write size */
   f=fopen(tmploc,"rb");/* open temp file for add data to database */
   while( (numerr=fread(exetxt,sizeof(char),2048,f))>0 )/* read buff */
   fwrite(exetxt,sizeof(char),numerr,d);/* write buffer */
   fclose(f);fclose(d);/* close temp and database file */
   printf(" Done.");fflush(NULL);
  }/* end if test==true */
 }/* end else check other options */
}/* end if E_OPT */
return(!test);
}/* end of geturlloc() */
