/******************************************************************************
    Program url2data, builds database from url address:
    - string.c - source file for manipulating with string lines.

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "url2data.h"

void decto94(int Ulbr,char *Izbr);

void getletters(char *Ulin,char *Icode)/* make code for no of letters */
{
int i,j,dec[8];
short int svi[96];

for(i=0;i<=96;i++) svi[i]=false;/* reset counters */
for(i=0;i<strlen(Ulin);i++)/* go thru line */
 if( (Ulin[i]>32)&&(Ulin[i]<127) ) svi[Ulin[i]-32]=true; /* select character */
dec[7]=1;dec[6]=2;dec[5]=4;dec[4]=8;dec[3]=16;/* set decimal numbers */
dec[2]=32;dec[1]=64;dec[0]=128;/* set decimal numbers */
for(i=0;i<12;i++){/* go thru numbers */
 Icode[i]=0;
 for(j=i*8;j<i*8+8;j++)/* go thru string */
  if(svi[j]) Icode[i]+=dec[j-i*8];
/* set to character code */
}/* end for i */
/* mark eos, last number is on place 11 */
}

void fix_line(char *Ulin) /* convert all other characters to '.' */
{
char buf[2048];
int i;

for(i=0;i<=strlen(Ulin);i++) /* go thru line */
 if( ((Ulin[i]>31)&&(Ulin[i]<127))||(Ulin[i]==0)||(Ulin[i]==10) )//||(Ulin[i]==13) )
  buf[i]=Ulin[i]; /* all ok copy character */
 else buf[i]='.'; /* unsuported character, convert it */
strcpy(Ulin,buf); /* return buf to line */
}

int decodeline(unsigned char *Ulin) /* mark line with signatures */
{
char buf[2048],word[2048];
int i,j,br,size;

size=0;br=0;/* reset values */
for(i=0;i<strlen(Ulin);i++){/* go thru line */
 if( (Ulin[i]>32)&&(Ulin[i]<127) ){/* found character */
  word[br]=Ulin[i];/* copy word */
  br++;/* start count letters in word */
 }else /* no character, write buf */
  if(br>0){/* word exists */
   buf[size]=br;size++;/* write size of word */
   for(j=size;j<=br+size;j++) buf[j]=word[j-size];/* write to buf */
   size=j-1;br=0;word[0]=0;/* reset value */
  }/* end if br, there isn't any word, skip */
}/* end for i */
bcopy(buf,Ulin,size);/* binary copy marked line */
return(size);/* return size of line */
}
