/******************************************************************************
    Program search.cgi, search thru database to match word(s):
    - search.c - source file for searching thru database

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "extern.h"

#ifdef _DOS_
short int strcasecmp(char S1[255], char S2[255]);
#endif

int getletters(char *Ulin,char *Icode);
void IgnoreCase(unsigned char *BLin);
void AddToLnk(int BrSec,int Where);
void replace(char *URLoc);
unsigned short int NOWord(char *Uword);
void cutspace(char *lin);

/******** Extract words from search string and give status (and,or,not) ******/
void get_word(char *words)
{
int i=0,j;
char WorD[MAX_WORDS][1024];

CUR_WORD=-1;/* reset words */
while (words[i]!=0){/* go thru line */
 CUR_WORD++;/* count founded words */
 switch (words[i]) {/* check type of search */
  case '+':/* Marked word with 'and' (+) status */
  	WordS[CUR_WORD].stat[0]=0;/* set to not found */
  	WordS[CUR_WORD].stat[1]=0;/* set as "and" */
  	i++;break;/* skipp + sign */
  case '-':/* Marked word with 'notand' (-) status */
   	WordS[CUR_WORD].stat[0]=0;/* set to not found */
   	WordS[CUR_WORD].stat[1]=-1;/* set as "notand" */
   	i++;break;/* skipp - sign */
  default:/* Marked word with 'or' ( ) status */
   	WordS[CUR_WORD].stat[0]=0;/* set to not found */
   	WordS[CUR_WORD].stat[1]=1;/* set as "or" */
	break;
 }/* end switch type of search  */
 j=i;WordS[CUR_WORD].sign[0]=0;WordS[CUR_WORD].sign[1]=1;/* set value */
 while( ((words[i]!=32)||(WordS[CUR_WORD].sign[1]=='\\')||\
		 WordS[CUR_WORD].sign[0])&&(words[i]!=0) )
 {/* go thru line */
  if( (words[i]==34)&&(WordS[CUR_WORD].sign[1]!='\\') ){/* found bratskets */
   if(!WordS[CUR_WORD].sign[0])/* test to where is current dump */
    WordS[CUR_WORD].sign[0]=true;/* set search to end of brasket */
   else WordS[CUR_WORD].sign[0]=false;/* set search to end of space character */
  }/* end if braskets */
  WorD[CUR_WORD][i-j]=words[i];WordS[CUR_WORD].sign[1]=words[i];i++;
 }/* copy that word */
 WorD[CUR_WORD][i-j]=0;/* mark end of word */
 while( (words[i]==' ')&&(words[i]!=0) ) i++;/* Skip space between words */
 if(WorD[CUR_WORD][0]==0) CUR_WORD--;/* Remove empty word ("") */
}/* end of while thru line */

for(i=0;i<=CUR_WORD;i++){/* go thru words */
 WordS[i].sign[0]=0;/* mark start possition */
 WordS[i].sign[1]=strlen(WorD[i]);/* mark end position */
 if(WorD[i][0]=='*'){ /* substring word */
  WordS[i].stat[1]+=3;WordS[i].stat[2]=-1;/* mark left substring */
  WordS[i].sign[0]=1;}/* mark start possition */
 if(WorD[i][strlen(WorD[i])-1]=='*'){ /* substring word */
  WordS[i].sign[1]=strlen(WorD[i])-1;/* mark end position */
  if(WordS[i].stat[1]>1){/* have substring */
   WordS[i].stat[2]=0;/* mark for all side substring */
  }else{/* only last substring */
   WordS[i].stat[1]+=3;WordS[i].stat[2]=1;}/* mark right substring */
 }/* end if substring word */
 j=WordS[i].sign[0];WordS[i].sign[2]=0;/* set word position*/
 while(j<=WordS[i].sign[1]){/* go thru word */
  if(WorD[i][j]=='\\'){/* found marcation*/
   j++;if(j<=WordS[i].sign[1]){/* not end of word */
    WorD[i][WordS[i].sign[2]]=WorD[i][j];
    WordS[i].sign[2]++;j++;}/* end if end of word */
  }else if(WorD[i][j]==34) j++;/* braskets, skip it */
   else{/* other letters */
    WorD[i][WordS[i].sign[2]]=WorD[i][j];/* copy character */
    WordS[i].sign[2]++;j++;}/* go to next character */
 }/* end while j */
 WorD[i][WordS[i].sign[2]-1]=0;
 cutspace(WorD[i]);/* remove more than one space character */
 strncpy(WordS[i].word,WorD[i],WORD_LENGHT);/* if word is bigger, cut it */
 WordS[i].word[WORD_LENGHT]=0;/* mark end of word if was bigger word */
 WordS[i].size=getletters(WordS[i].word,WordS[i].sign);/* build 12 bit sign */
 WordS[i].total=NOWord(WordS[i].word);WordS[i].found=0;/* reset marcation */
}/* end for i */
i=0;while(i<=CUR_WORD){/* go thru words */
 if(WordS[i].word[0]==0){/* Remove empty word ("") */
  for(j=i;j<CUR_WORD;j++){/* go thru rest of the words */
   strcpy(WordS[j].word,WordS[j+1].word);/* copy word from next */
   WordS[j].stat[1]=WordS[j+1].stat[1];WordS[j].stat[2]=WordS[j+1].stat[2];
   memcpy(WordS[j].sign,WordS[j+1].sign,12);/* copy signature */
   WordS[j].size=WordS[j+1].size;WordS[j].total=WordS[j+1].total;
   WordS[j].found=WordS[j+1].found;/* copy size and marcation */
  } CUR_WORD--;/* end for j */
 }else i++;/* word ok, go to next */
}/* end while i */
}/* end get_word() */

/********************** testing for match words in line ******************/
short int IsInLine(unsigned char *lin)
{
int i,j;
short int atest,test;

atest=false;
for(i=0;i<=CUR_WORD;i++){/* go thru words and compare signatures */
 if(WordS[i].stat[0]<=0){/* scan only not yet matched words */
  test=true;
  for(j=0;(j<=11)&&test;j++)/* go thru signature */
   if( ((WordS[i].sign[j] & lin[j])!=WordS[i].sign[j])&&\
	((WordS[i].sign[j] & lin[j])!=lin[j])) test=false;
  if(WordS[i].found!=0) test=true;/* continue testing multi words */
  if(test){ WordS[i].stat[0]=-1;atest=true;/* found word, mark it */
  }else WordS[i].stat[0]=0;/* reset to default */
 }/* end if not matched */
}/* end for i */
return(atest);
}/* end IsInLine() */

/******************************* test substring *****************************/
short int strscmp(unsigned char TstWord[WORD_LENGHT],\
		unsigned char FixWord[256],short int FromWhere)
{
int i,b,e;
short int test;

test=false;
switch (FromWhere) {/* scan type of match */
 case -1:/* scan from end (*XXX) */
	 b=strlen(FixWord)-strlen(TstWord);/* begining of word */
	 e=strlen(FixWord);/* end of word */
	 for(i=b;i<=e;i++) FixWord[i-b]=FixWord[i];/* exstract word */
	 if(TypCase){/* doing match case compare */
	  if(strcmp(TstWord,FixWord)==0) test=true;/* found word */
	 }else{/* doing ignore case compare */
	  if(strcasecmp(TstWord,FixWord)==0) test=true;/* found word */
	 }break;
 case 0:/* scan from all sides (*XXX*) */
	 b=0;e=strlen(FixWord)-b;i=strlen(TstWord);/* strlen() bug fix */
	 while( (e>=i)&&!test ){/* go thru word */
	  e=strlen(FixWord)-strlen(TstWord);/* free for test */
	  if(TypCase){/* doing match case scan letter */
	   while( (FixWord[b]!=TstWord[0])&&(b<=e) ) b++;
	  }else{/* doing ignore case scan letter */
	   while( (tolower(FixWord[b])!=tolower(TstWord[0]))&&(b<=e) ) b++;
	  }/* end else if case */
	  e=b+strlen(TstWord)-1;/* end of word */
	  if(e<strlen(FixWord)){/* word o.k. do test */
	   test=true;for(i=b;i<=e;i++){/* compare characters */
	    if(TypCase){/* doing match case compare */
	     if(FixWord[i]!=TstWord[i-b]) test=false;
	    }else{/* doing ignore case compare */
	     if(tolower(FixWord[i])!=tolower(TstWord[i-b])) test=false;
	    }/* end else igrnore case */
	   }/* end for i */
	  }/* end if e */
	  if(!test) b++;/* go to next letter */
	  e=strlen(FixWord)-b;i=strlen(TstWord);/* strlen() bug fix */
	 }/* end while b */
	 break;
 case 1:/* scan from beggining (XXX*) */
	 FixWord[strlen(TstWord)]=0;/* exstract word */
	 if(TypCase){/* doing match case compare */
	  if(strcmp(TstWord,FixWord)==0) test=true;/* found word */
	 }else{/* doing ignore case compare */
	  if(strcasecmp(TstWord,FixWord)==0) test=true;/* found word */
	 }/* end else igrnore case */
	 break;
  case 2:/* regular match (XXX) */
	 if(TypCase){/* doing match case compare */
	  if(strcmp(TstWord,FixWord)==0) test=true;/* found word */
	 }else{/* doing ignore case compare */
	  if(strcasecmp(TstWord,FixWord)==0) test=true;/* found word */
	 }/* end else igrnore case */
	 break;
  default:/* Hmh? error? */
	 printf("Substring match error, unknown method for matching: %d<BR>\n\
		 Failed on: [%s]=?=[%s]<BR>\n",FromWhere,TstWord,FixWord);
	 fflush(NULL);break;
}/* end switch */
return(test);
}

/*************************** test if word match *****************************/
void testwords(char *TestWord)
{
int i,j,k;
char tmp[WORD_LENGHT];

for(i=0;i<=CUR_WORD;i++){/* go thru words and compare size */
 if(WordS[i].stat[0]==-2){/* compare only matched word */
  if(WordS[i].stat[1]<=1){/* it's regular word */
   if(TypCase){/* using match case */
    if(WordS[i].total!=1){ /* word with space char continue scan */
     k=1;j=0;while((WordS[i].word[j])&&(k<=WordS[i].found)){
      j++;if(WordS[i].word[j]==32) k++;}/* find begining of next word */
     j++;if(j==1) j=0;/* reset begining of first word */
     k=j;while(((WordS[i].word[j]!=32)&&(WordS[i].word[j]!=0))&&\
		(WordS[i].word[j]==TestWord[j-k])) j++;
     if(((WordS[i].word[j]==32)||(WordS[i].word[j]==0))&&(TestWord[j-k]==0)){
      WordS[i].found++;WordS[i].stat[0]=-1;/* set found word */
      if(WordS[i].found==WordS[i].total){/* found all words */
       WordS[i].stat[0]=1;WordS[i].found=0;}/* mark as found */
     }else{ WordS[i].stat[0]=-1;WordS[i].found=0;}/* words not match, reset */
     if(WordS[i].stat[0]==1){/* word found */
      if(WordS[i].stat[1]==-1){/* word is "not" type, mark all as found */
       for(j=0;j<=CUR_WORD;j++) WordS[j].stat[0]=1;}/* end marking */
      if(WordS[i].stat[1]==1){/* word is "or" type, mark all "or" as found */
       for(j=0;j<=CUR_WORD;j++){/* go to find "or" type of words */ 
        if((WordS[j].stat[1]==1)||(WordS[j].stat[1]==4))/* found "or" type */
         WordS[j].stat[0]=1;
       }/* end for j */
      }/* end marking */
     }/* end if word found */
    }else{ /* regular word */
     if(strcmp(WordS[i].word,TestWord)==0){/* mark words */
      if(WordS[i].stat[1]==-1){/* word is "not" type, mark all as found */
       for(j=0;j<=CUR_WORD;j++) WordS[j].stat[0]=1;}/* end marking */
      if(WordS[i].stat[1]==1){/* word is "or" type, mark all "or" as found */
       for(j=0;j<=CUR_WORD;j++){/* go to find "or" type of words */ 
        if((WordS[j].stat[1]==1)||(WordS[j].stat[1]==4))/* found "or" type */
         WordS[j].stat[0]=1;
       }/* end for j */
      }/* end marking */
      WordS[i].stat[0]=1;/* mark current as found */
     }else WordS[i].stat[0]=-1;/* word not match, skipp it */
    }/* end else if space char */
   }else{/* using ignore case */
    if(WordS[i].total!=1){ /* word with space char continue scan */
     k=1;j=0;while((WordS[i].word[j])&&(k<=WordS[i].found)){
      j++;if(WordS[i].word[j]==32) k++;}/* find begining of next word */
     j++;if(j==1) j=0;/* reset begining of first word */
     k=j;while(((WordS[i].word[j]!=32)&&(WordS[i].word[j]!=0))&&\
		(tolower(WordS[i].word[j])==tolower(TestWord[j-k]))) j++;
     if(((WordS[i].word[j]==32)||(WordS[i].word[j]==0))&&(TestWord[j-k]==0)){
      WordS[i].found++;WordS[i].stat[0]=-1;/* set found word */
      if(WordS[i].found==WordS[i].total){/* found all words */
       WordS[i].stat[0]=1;WordS[i].found=0;}/* mark as found */
     }else{ WordS[i].stat[0]=-1;WordS[i].found=0;}/* words not match, reset */
     if(WordS[i].stat[0]==1){/* word found */
      if(WordS[i].stat[1]==-1){/* word is "not" type, mark all as found */
       for(j=0;j<=CUR_WORD;j++) WordS[j].stat[0]=1;}/* end marking */
      if(WordS[i].stat[1]==1){/* word is "or" type, mark all "or" as found */
       for(j=0;j<=CUR_WORD;j++){/* go to find "or" type of words */ 
        if((WordS[j].stat[1]==1)||(WordS[j].stat[1]==4))/* found "or" type */
         WordS[j].stat[0]=1;
       }/* end for j */
      }/* end marking */
     }/* end if word found */
    }else{ /* regular word */
     if(strcasecmp(WordS[i].word,TestWord)==0){/* mark words */
      if(WordS[i].stat[1]==-1){/* word is "not" type, mark all as found */
       for(j=0;j<=CUR_WORD;j++) WordS[j].stat[0]=1;}/* end marking */
      if(WordS[i].stat[1]==1){/* word is "or" type, mark all "or" as found */
       for(j=0;j<=CUR_WORD;j++){/* go to find "or" type of words */ 
        if((WordS[j].stat[1]==1)||(WordS[j].stat[1]==4))/* found "or" type */
         WordS[j].stat[0]=1;
       }/* end for j */
      }/* end marking */
      WordS[i].stat[0]=1;/* mark current as found */
     }else WordS[i].stat[0]=-1;/* word not match, skipp it */
    }/* end else if space char */
   }/* end else ignore case */
  }else{/* it's substring word */
   if(WordS[i].total!=1){ /* word with space char continue scan */
    k=1;j=0;while((WordS[i].word[j])&&(k<=WordS[i].found)){
     j++;if(WordS[i].word[j]==32) k++;}/* find begining of next word */
    j++;if(j==1) j=0;/* reset begining of first word */
    k=j;while((WordS[i].word[j]!=32)&&(WordS[i].word[j]!=0)){
     tmp[j-k]=WordS[i].word[j]; j++;} tmp[j-k]=0;/* copy word */
    if( ((WordS[i].stat[2]==0)||(WordS[i].stat[2]==-1))&&\
     (WordS[i].found==0) ) k=-1;/* substring at begining */
    else if( ((WordS[i].stat[2]==0)||(WordS[i].stat[2]==1))&&\
     (WordS[i].found==WordS[i].total-1)) k=1;/* substring at end */
    else k=2;/* match only */
    if(strscmp(tmp,TestWord,k)){/* match with substring */
     WordS[i].found++;WordS[i].stat[0]=-1;/* set found word */
     if(WordS[i].found==WordS[i].total){/* found all words */
      WordS[i].stat[0]=1;WordS[i].found=0;}/* mark as found */
    }else{ WordS[i].stat[0]=-1;WordS[i].found=0;}/* words not match, reset */
    if(WordS[i].stat[0]==1){/* word found */
     if(WordS[i].stat[1]==-1){/* word is "not" type, mark all as found */
      for(j=0;j<=CUR_WORD;j++) WordS[j].stat[0]=1;}/* end marking */
     if(WordS[i].stat[1]==1){/* word is "or" type, mark all "or" as found */
      for(j=0;j<=CUR_WORD;j++){/* go to find "or" type of words */ 
       if((WordS[j].stat[1]==1)||(WordS[j].stat[1]==4))/* found "or" type */
        WordS[j].stat[0]=1;
      }/* end for j */
     }/* end marking */
    }/* end if word found */
   }else{ /* regular word */
    if(strscmp(WordS[i].word,TestWord,WordS[i].stat[2])){
     if(WordS[i].stat[1]==2){/* word is "not" type, mark all as found */
      for(j=0;j<=CUR_WORD;j++) WordS[j].stat[0]=1;}/* end marking */
     if(WordS[i].stat[1]==4){/* word is "or" type, mark all "or" as found */
      for(j=0;j<=CUR_WORD;j++){/* go to find "or" type of words */ 
       if((WordS[j].stat[1]==1)||(WordS[j].stat[1]==4))/* found "or" type */
        WordS[j].stat[0]=1;
      }/* end for j */
     }/* end marking */
     WordS[i].stat[0]=1;/* mark current as found */
    }else WordS[i].stat[0]=-1;/* word not match, skipp it */
   }/* end else if space char */
  }/* end else substr */
 }/* end stat -2 */
}/* end for i */
}/* end testwords() */

/************************ Main search program *******************************/
void search(int SeC,short int IspiS)
{
FILE *f;
unsigned char UrlLoc[1024],UrlDate[80],UrlTitle[130],UrlDescr[122],lin[256];
unsigned char HoW;/* height of word */
long dataseek;
int i,HoL;/* height of line */
short int status;

if(IspiS) printf("Search rezults in <B>%s</B>:<BR>\n",section[SeC].name);
else printf("Total found in <B>");
fflush(NULL);dataseek=0;CCounT=0;/* flush buffers */
if( (f=fopen(section[SeC].path,"rb"))==NULL )/* failed to open database */
 printf("Error reading database file: [%s]\n<BR>",section[SeC].path);
else{/* all ok continue */
 while(!feof(f)){/* go thru database */
  if( (!TypPage)&&(CCounT>=20*CounT) )
   fseek(f,0L,SEEK_END);/* if limit, go to end of file */
  lin[0]=0;lin[0]=fgetc(f);/* read first character */
  switch (lin[0]) {/* test type of record */
   case 255:/* url location */
   	fgets(UrlLoc,1025,f);UrlLoc[strlen(UrlLoc)-1]=0;break;/* read url */
   case 254:/* date information */
	fgets(UrlDate,81,f);UrlDate[strlen(UrlDate)-1]=0;break;/* read date */
   case 253:/* size of data */
	lin[0]=fgetc(f);lin[1]=fgetc(f);lin[2]=fgetc(f);lin[3]=fgetc(f);
	dataseek=lin[0]*16777216+lin[1]*65536+lin[2]*256+lin[3];
	lin[0]=0;break;/* data offset*/
   case 252:/* title of url */
	dataseek--;fgets(UrlTitle,130,f);dataseek-=strlen(UrlTitle);
	if(UrlTitle[0]==10) strcpy(UrlTitle,UrlLoc);/* no title */
	else{/* set title */
	 UrlTitle[strlen(UrlTitle)-1]=0;if( UrlTitle[0]==32 ) UrlTitle[0]='_';
	}break;/* read title */
   default:/* scan for description */
	dataseek--;/* status=false;HoL=0;*//* Heigh of line */
        if(lin[0]==251){/* description is here */
	 fgets(UrlDescr,122,f);dataseek-=strlen(UrlDescr);
	 UrlDescr[strlen(UrlDescr)-1]=0;/* description */
	}else{/* hm... possible error? */
	 printf("Catch unreferenced value: [%c]-%d<BR>\n",lin[0],lin[0]);break;}
	while(dataseek>0){/* go thru rest of data */
	 for(i=0;i<12;i++) lin[i]=fgetc(f);dataseek-=12;/* read line signature*/
	 if(!TypCase) IgnoreCase(lin); /* convert if is ignore case */
	 if(IsInLine(lin)){/* word culd be in this line do search */
	  lin[0]=fgetc(f);lin[1]=fgetc(f);dataseek-=2;HoL=lin[0]*256+lin[1];
	  while(HoL>0){/* go thru line */
	   HoW=fgetc(f);HoL--;dataseek--;status=false;/* get size of word */
	   for(i=0;i<=CUR_WORD;i++){/* go thru words and compare size */
	    if(WordS[i].stat[0]==-1){/* compare only not matched word */
	     if(WordS[i].found!=0){WordS[i].stat[0]=-2;status=true;
	     }else{/* mark word for testing or else test it */
	      if(WordS[i].stat[1]>1){/* it's substring word */
	       if((WordS[i].stat[2]!=1)&&(WordS[i].total>1)){
		WordS[i].stat[0]=-2;status=true;}/* word with space */
	       if(WordS[i].size<=HoW){/* it could be it, test it */
	        WordS[i].stat[0]=-2;status=true;}/* mark word for testing */
	      }else{/* it's regular word */
	       if(WordS[i].size==HoW){/* it could be it, test it */
	        WordS[i].stat[0]=-2;status=true;}/* mark word for testing */
	      }/* end else regular */
	     }/* end else if word with space */
	    }/* end if matched word */
	   }/* end for i */
	   if(status){/* Possible word, do test that word */
	    fgets(lin,HoW+1,f);/* read word */
	    testwords(lin);/* test if word match */
	   }else fseek(f,HoW,SEEK_CUR);/* isn't possible word, skipp it */
	   HoL-=HoW;dataseek-=HoW;/* mark skipped letters */
	  }/* end while HoL */
	 }else{/* no one word isn't in this line, skipp line */
	  lin[0]=fgetc(f);lin[1]=fgetc(f);dataseek-=2;HoL=lin[0]*256+lin[1];
	  fseek(f,HoL,SEEK_CUR);dataseek-=HoL;/* skipping line */
	 }/* end else isn't in line */
	}/* end of while thru data */
	status=true;
	for(i=0;(i<=CUR_WORD)&&status;i++){/* go thru words */
	 if( (WordS[i].stat[1]==-1)||(WordS[i].stat[1]==2) ){/* "notand" word*/
	  if(WordS[i].stat[0]==1) status=false;/* not found all words */
	 }else{/* other words */
	  if(WordS[i].stat[0]!=1) status=false;/* not found all words */
	 }/* end else if words "notand" */
	}/* end for i */
	if(IspiS){/* status for display rezults */
	 if(status){/* found all words write location */
	  CCounT++;/* count match */
	  if( (CCounT>=SCounT)&&(CCounT<CounT+SCounT) ){/* display rezults */
	   if(REPLACE[0]!=0) replace(UrlLoc);/* replace file exist,do replace */
	   printf("<DL><DT>\n<B>%d. </B><A HREF=\"%s\">",CCounT,UrlLoc);
	   printf("<B>%s</B></A></DT>\n<DD>%s...\n",UrlTitle,UrlDescr);
	   printf("<BR><B>URL:</B> <FONT COLOR=\"%s\">%s<BR>\n",RezCol,UrlLoc);
	   printf("%s</FONT><BR>\n</DD></DL>\n",UrlDate);
	   fflush(NULL);/* end if CCounT */
	  }/* end if of display rezult */
	 }/* end if status */
	}else if(status) CCounT++;/* found all words mark it */
	for(i=0;i<=CUR_WORD;i++)/* go thru words */
	 WordS[i].stat[0]=0;WordS[i].found=0;/* reset words */
  	break;/* end of default */
  }/* end switch */
 }/* end of while thru database */
 if(IspiS){/* status for display rezults */
  if(CCounT>CounT){/* ok there is more data to display */ 
   printf("<FONT SIZE=-1>Result Pages: ");
   HoL=div(div(SCounT,CounT).quot,20).quot;
   if(SCounT>10){/* display prev link */
    AddToLnk(SeC,SCounT-CounT);printf("[&lt;&lt; Previous]</A>\n");}/* end if */

   if( (div(div(CCounT,CounT).quot,20).quot>0)&&(HoL>=1) ){/* -20 more */
    AddToLnk(SeC,(HoL*20-1)*CounT+1);printf("<B>[&lt;&lt;]</B></A>\n");}

   for(i=1+HoL*20;i<=div(SCounT,CounT).quot;i++){/* links before rezult page */
    AddToLnk(SeC,(i-1)*CounT+1);printf("%d</A>\n",i);}/* end for i */

   printf("<B>%d</B>\n",div(SCounT+CounT,CounT).quot);/* current display page */

   for(i=div(SCounT+CounT,CounT).quot;i<=(div(CCounT,CounT).quot)&&\
	(i<(HoL+1)*20);i++){/* links after rezult page */
    if(i*CounT+1<=CCounT){/* owerflow bug fix */
     AddToLnk(SeC,i*CounT+1);printf("%d</A>\n",i+1);}
   }/* end for i */
   
   i=div(div(CCounT,CounT).quot,20).quot;
   if( (i>0)&&(HoL<i) ){/* +20 more */
    if((HoL+1)*20*CounT+1<=CCounT){/* owerflow bug fix */
    AddToLnk(SeC,(HoL+1)*20*CounT+1);printf("[&gt;&gt;]</A>\n");}}
   
   if(SCounT+CounT<=CCounT){/* ok it's not last link */
   AddToLnk(SeC,SCounT+CounT);printf("[Next &gt;&gt;]</A>\n");}/* last */
   printf("<BR>\n");
  }/* end if more data */
  printf("Total found ");if( (!TypPage)&&(CCounT>=20*CounT) ) printf("about ");
  printf("<B>%d</B> Urls which match to requested word",CCounT);
  if( (!TypPage)&&(CCounT>=20*CounT) )
  if(CUR_WORD>1) printf("s");printf(".</FONT>\n");
 }else{/* write hits */
  AddToLnk(SeC,0);/* generate link */
  printf("%s</B></A>-%d Urls<BR>\n",section[SeC].name,CCounT);fflush(NULL);
 }/* end else if ispis */
 fflush(NULL);fclose(f);
}/* end else open database */
}/* end search() */
